
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>MIT_Classes &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for MIT_Classes</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">Cleaning</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">math</span>
<span class="kn">import</span> <span class="nn">h5py</span>

<div class="viewcode-block" id="Dataset_MIT"><a class="viewcode-back" href="../sphinx/MIT.html#MIT_Classes.Dataset_MIT">[docs]</a><span class="k">class</span> <span class="nc">Dataset_MIT</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Severson et al. dataset from &quot;Data-driven prediction of battery cycle</span>
<span class="sd">    life before capacity degradation&quot; (check note for full reference).</span>

<span class="sd">    .. note::</span>
<span class="sd">        Full reference: Severson, K.A., Attia, P.M., Jin, N. et al.</span>
<span class="sd">        Data-driven prediction of battery cycle life before capacity</span>
<span class="sd">        degradation. Nat Energy 4, 383–391 (2019).</span>
<span class="sd">        &lt;https://doi.org/10.1038/s41560-019-0356-8&gt;</span>

<span class="sd">    .. note::</span>
<span class="sd">        Thorough information about each dataset can be found at:</span>
<span class="sd">        &lt;https://data.matr.io/1/projects/5c48dd2bc625d700019f3204&gt;</span>

<span class="sd">    Parameters:</span>
<span class="sd">    -----------</span>
<span class="sd">    f : HDF5 File</span>
<span class="sd">        The HDF5 File (h5py.File) object corresponding to the file itself.</span>
<span class="sd">        It is necessary since it&#39;s called during the cycle creation.</span>
<span class="sd">    battery_number : int</span>
<span class="sd">        The battery number.</span>
<span class="sd">    print_bool : bool</span>
<span class="sd">        Toggles some information printing on and off (number of cycles, etc.).</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    Name : str</span>
<span class="sd">        The battery&#39;s name. It is created based on the battery number.</span>
<span class="sd">        The number is padded with zeros in order to contain 4 digits.</span>
<span class="sd">        If battery_number = 12, then the battery Name will be B0012.</span>
<span class="sd">    cycle_life : float</span>
<span class="sd">        The battery&#39;s cycle life (based on 20% nominal capacity degradation -</span>
<span class="sd">        going from 1.10 A.h to 0.88 A.h).</span>
<span class="sd">    policy : str</span>
<span class="sd">        A string containing information about the charge cycle.</span>

<span class="sd">        It&#39;s written in the format &quot;C1(Q1)-C2&quot;. C1 is the first C rate used</span>
<span class="sd">        for charging, Q1 is the SOC where this first charging step stops and</span>
<span class="sd">        C2 is the second C rate used for charging.</span>
<span class="sd">    cycle : list(MIT_Cycle)</span>
<span class="sd">        List containing the cycling information. See MIT_Cycle class.</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; f = h5py.File(&#39;2017-06-30_batchdata_updated_struct_errorcorrect.mat&#39;)</span>
<span class="sd">    &gt;&gt;&gt; battery_number = 24</span>
<span class="sd">    &gt;&gt;&gt; B = Dataset_MIT(f, battery_number, print_bool=True)</span>
<span class="sd">    &gt;&gt;&gt; B.policy</span>
<span class="sd">    &#39;4.8C(80%)-4.8C&#39; # in this case the 1st and second charges are at the same</span>
<span class="sd">                     # C rate.</span>
<span class="sd">    &gt;&gt;&gt; B.Name</span>
<span class="sd">    &#39;B0024&#39;</span>
<span class="sd">    &gt;&gt;&gt; B.cycle_life</span>
<span class="sd">    495.0</span>
<span class="sd">    &gt;&gt;&gt; len(B.cycle)</span>
<span class="sd">    524</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">battery_number</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>

        <span class="c1"># Battery name:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">battery_number</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span>

        <span class="c1"># Cycle_life:</span>
        <span class="n">cycle_life_ref</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="s1">&#39;batch&#39;</span><span class="p">][</span><span class="s1">&#39;cycle_life&#39;</span><span class="p">][</span><span class="n">battery_number</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span>
        <span class="n">cycle_life</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="n">cycle_life_ref</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_life</span> <span class="o">=</span> <span class="n">cycle_life</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span><span class="mi">0</span><span class="p">]</span> <span class="c1"># float</span>

        <span class="c1"># Policy:</span>
        <span class="n">policy_ref</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="s1">&#39;batch&#39;</span><span class="p">][</span><span class="s1">&#39;policy_readable&#39;</span><span class="p">][</span><span class="n">battery_number</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span>
        <span class="n">policy</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="n">policy_ref</span><span class="p">]</span>
        <span class="n">policy_str</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">policy</span><span class="p">)):</span>
            <span class="n">policy_str</span> <span class="o">+=</span> <span class="n">policy</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">tobytes</span><span class="p">()[::</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">decode</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">policy</span> <span class="o">=</span> <span class="n">policy_str</span>

        <span class="c1"># Cycling data:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="c1"># Summary (will be called for each cycle):</span>
        <span class="n">summary_ref</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="s1">&#39;batch&#39;</span><span class="p">][</span><span class="s1">&#39;summary&#39;</span><span class="p">][</span><span class="n">battery_number</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span>
        <span class="n">summary</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="n">summary_ref</span><span class="p">]</span>

        <span class="c1"># Cycling data (will be called for each cycle):</span>
        <span class="n">battery_ref</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="s1">&#39;batch&#39;</span><span class="p">][</span><span class="s1">&#39;cycles&#39;</span><span class="p">][</span><span class="n">battery_number</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span>
        <span class="n">battery</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="n">battery_ref</span><span class="p">]</span>

        <span class="k">if</span> <span class="n">print_bool</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Number of cycles: &#39;</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">battery</span><span class="p">[</span><span class="s1">&#39;I&#39;</span><span class="p">]))</span>

        <span class="k">for</span> <span class="n">cycle_nb</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">battery</span><span class="p">[</span><span class="s1">&#39;I&#39;</span><span class="p">])):</span>
            <span class="c1"># print(Cycle_nb)</span>
            <span class="n">Cycle</span> <span class="o">=</span> <span class="n">MIT_Cycle</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">battery</span><span class="p">,</span> <span class="n">summary</span><span class="p">,</span> <span class="n">cycle_nb</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Cycle</span><span class="p">)</span></div>

<div class="viewcode-block" id="MIT_Cycle"><a class="viewcode-back" href="../sphinx/MIT.html#MIT_Classes.MIT_Cycle">[docs]</a><span class="k">class</span> <span class="nc">MIT_Cycle</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    A Cycle class for the Severson dataset.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    f : HDF5 File</span>
<span class="sd">        The HDF5 File (h5py.File) object corresponding to the file itself.</span>
<span class="sd">    battery : HDF5 group</span>
<span class="sd">        The group containing the cycling information for each cycle.</span>
<span class="sd">    summary : HDF5 group</span>
<span class="sd">        The group containing the summary information for each cycle.</span>
<span class="sd">    Cycle_nb : int</span>
<span class="sd">        The Cycle&#39;s number.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    number : int</span>
<span class="sd">        The cycle&#39;s number.</span>
<span class="sd">    amb_T : int</span>
<span class="sd">        The cycle&#39;s ambient temperature. They were all done at 30ºC.</span>
<span class="sd">        This is saved to try to agree as much as possible with the Nasa_Cycle</span>
<span class="sd">        class as well as to document this detail.</span>
<span class="sd">    summary_keys : list</span>
<span class="sd">        A list containing the name of the following attributes:</span>

<span class="sd">        IR : float</span>
<span class="sd">            Measured internal resistance.</span>
<span class="sd">        QCharge : float</span>
<span class="sd">            The charge cycle&#39;s capacity.</span>
<span class="sd">        QDischarge : float</span>
<span class="sd">            The discharge cycle&#39;s capacity.</span>
<span class="sd">        Tavg : float</span>
<span class="sd">            The cycle&#39;s average temperature.</span>
<span class="sd">        Tmax : float</span>
<span class="sd">            The cycle&#39;s maximum temperature.</span>
<span class="sd">        Tmin : float</span>
<span class="sd">            The cycle&#39;s minimum temperature.</span>
<span class="sd">        chargetime : float</span>
<span class="sd">            The charge cycle&#39;s duration.</span>
<span class="sd">        cycle : float</span>
<span class="sd">            The cycle number + 1.</span>

<span class="sd">    battery_keys : list</span>
<span class="sd">        A list containing the name of the variables stored in the battery group.</span>
<span class="sd">    data : MIT_Data</span>
<span class="sd">        The Severson_Data class with all of the important data.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">f</span><span class="p">,</span> <span class="n">battery</span><span class="p">,</span> <span class="n">summary</span><span class="p">,</span> <span class="n">Cycle_nb</span><span class="p">):</span>

        <span class="c1"># Cycle number:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">Cycle_nb</span>
        <span class="c1"># Ambient temperature (is the same for all of the dataset):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="mi">30</span>

        <span class="c1"># Summary information:</span>
        <span class="n">keys</span> <span class="o">=</span> <span class="n">summary</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">summary_keys</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">keys</span><span class="p">)</span>  <span class="c1"># So that we can always check the</span>
                                        <span class="c1"># attributes&#39; names.</span>
        <span class="c1"># keys = [&#39;IR&#39;, &#39;QCharge&#39;, &#39;QDischarge&#39;, &#39;Tavg&#39;, &#39;Tmax&#39;, &#39;Tmin&#39;,</span>
        <span class="c1"># &#39;chargetime&#39;, &#39;cycle&#39;]</span>

        <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">summary</span><span class="p">[</span><span class="n">key</span><span class="p">][</span><span class="mi">0</span><span class="p">,</span> <span class="n">Cycle_nb</span><span class="p">])</span>

        <span class="c1"># Battery information</span>
        <span class="n">keys</span> <span class="o">=</span> <span class="n">battery</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">battery_keys</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">keys</span><span class="p">)</span>
        <span class="n">battery_dict</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">:</span>
            <span class="n">key_ref</span> <span class="o">=</span> <span class="n">battery</span><span class="p">[</span><span class="n">key</span><span class="p">][</span><span class="n">Cycle_nb</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span>
            <span class="n">key_dataset</span> <span class="o">=</span> <span class="n">f</span><span class="p">[</span><span class="n">key_ref</span><span class="p">]</span>
            <span class="n">key_array</span> <span class="o">=</span> <span class="n">key_dataset</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="p">:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="c1"># Will hold the information for all of the data, temporarily:</span>
            <span class="n">battery_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">key_array</span><span class="o">.</span><span class="n">reshape</span><span class="p">([</span><span class="nb">len</span><span class="p">(</span><span class="n">key_array</span><span class="p">),</span> <span class="mi">1</span><span class="p">])</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">MIT_Data</span><span class="p">(</span><span class="n">battery_dict</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">QDischarge</span><span class="p">)</span>  <span class="c1"># The actual data</span></div>

<div class="viewcode-block" id="MIT_Data"><a class="viewcode-back" href="../sphinx/MIT.html#MIT_Classes.MIT_Data">[docs]</a><span class="k">class</span> <span class="nc">MIT_Data</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Data class for the Severson dataset.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    battery_dict : dict</span>
<span class="sd">        Dictionary containing all of the data arrays.</span>
<span class="sd">    capacity : float</span>
<span class="sd">        The battery&#39;s calculated discharge capacity at the end of the cycle.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    time : ndarray[floats]</span>
<span class="sd">        Time vector for the cycle [min].</span>
<span class="sd">    meas_v : ndarray[floats]</span>
<span class="sd">        Battery terminal voltage [V].</span>
<span class="sd">    meas_i : ndarray[floats]</span>
<span class="sd">        Battery output current [A].</span>
<span class="sd">    meas_t : ndarray[floats]</span>
<span class="sd">        Battery temperature [ºC].</span>
<span class="sd">    capacity : float</span>
<span class="sd">        The battery&#39;s calculated discharge capacity at the end of the cycle [A.h].</span>
<span class="sd">    dis_capacity : ndarray[floats]</span>
<span class="sd">        The battery discharge capacity evolution during cycling [A.h].</span>
<span class="sd">    chr_capacity : ndarray[floats]</span>
<span class="sd">        The battery charge capacity during cycling [A.h].</span>
<span class="sd">    dis_dQdV : ndarray[floats]</span>
<span class="sd">        The differential capacity curve calculated from the discharge data.</span>
<span class="sd">    Qdlin : ndarray[floats]</span>
<span class="sd">        Linearly interpolated capacity information (?).</span>
<span class="sd">    Tdlin : ndarray[floats]</span>
<span class="sd">        Linearly interpolated temperature information (?).</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># def __init__(self, Data, Type, Qd = None):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">battery_dict</span><span class="p">,</span> <span class="n">capacity</span><span class="p">):</span>

        <span class="c1"># Cycle information is also present in the Nasa dataset:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;I&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;V&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_t</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;T&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="n">capacity</span>

        <span class="c1"># Information during cycling that will likely be unused:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dis_capacity</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;Qd&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">chr_capacity</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;Qc&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dis_dQdV</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;discharge_dQdV&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Qdlin</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;Qdlin&#39;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Tdlin</span> <span class="o">=</span> <span class="n">battery_dict</span><span class="p">[</span><span class="s1">&#39;Tdlin&#39;</span><span class="p">]</span></div>

<div class="viewcode-block" id="Clean_MIT_Battery"><a class="viewcode-back" href="../sphinx/MIT.html#MIT_Classes.Clean_MIT_Battery">[docs]</a><span class="k">class</span> <span class="nc">Clean_MIT_Battery</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class that holds the cleaned cycle couples and their data for one Battery.</span>

<span class="sd">    It takes as a base one Dataset_Severson class (one Battery from the Severson</span>
<span class="sd">    Dataset). From it, it extracts the cycle couples and cleans each one</span>
<span class="sd">    of them, excluding those that present abnormalities.</span>

<span class="sd">    It cleans the discharge cycle by taking away the first few points before the</span>
<span class="sd">    actual cycle begins and the last ones after the current has reached its</span>
<span class="sd">    cut-off point (&lt; ``i_cutoff``).</span>

<span class="sd">    Couples are excluded in this process when:</span>
<span class="sd">        The discharge curve&#39;s capacity value is nan, or it&#39;s below the</span>
<span class="sd">        ``threshold`` value.</span>
<span class="sd">        When the charge cycle is too short (&lt; ``min_len``).</span>
<span class="sd">    The cycle couples that weren&#39;t excluded then pass by an outlier detection</span>
<span class="sd">    based on the capacity value. Outliers are detected by sliding windows and</span>
<span class="sd">    z-score values (mainly sliding windows, small ``z_lim`` values yielded bad</span>
<span class="sd">    results, incorrectly excluding large amounts of the dataset).</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Battery : Dataset_MIT</span>
<span class="sd">        The battery we want to create the class for.</span>
<span class="sd">    threshold : float, default = 0.1</span>
<span class="sd">        the minimum capacity value to be considered as relevant [A.h].</span>
<span class="sd">    i_cutoff : float, default = 1.1/50</span>
<span class="sd">        The current cut-off value to be used to determine the end of the charge</span>
<span class="sd">        cycles [A].</span>
<span class="sd">    min_len : int, default = 1</span>
<span class="sd">        The minimum amount of points a charge cycle must have to be considered</span>
<span class="sd">        as relevant. Equal to one by default. Something similar is done during</span>
<span class="sd">        the resampling stages in the dataset creation.</span>
<span class="sd">    zlim : float, default = 6</span>
<span class="sd">        The maximum zscore allowed when searching for outliers.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    Name : string</span>
<span class="sd">        The battery&#39;s name.</span>
<span class="sd">    cycle_life : float</span>
<span class="sd">        The battery&#39;s cycle life (based on 20% nominal capacity degradation -</span>
<span class="sd">        going from 1.10 A.h to 0.88 A.h).</span>
<span class="sd">    policy : str</span>
<span class="sd">        A string containing information about the charge cycle.</span>
<span class="sd">        Check ``Dataset_Severson``&#39;s documentation for more information.</span>
<span class="sd">    capacity_curve : ndarray[float, float]</span>
<span class="sd">        A 2D array where the first column corresponds to the cycle couple number</span>
<span class="sd">        and the second to the associated capacity value [[], A.h].</span>
<span class="sd">    cycle_couple : list[tuple(Clean_MIT_Cycle)]</span>
<span class="sd">        The Clean_Cycle objects corresponding to each couple.</span>

<span class="sd">        .. code-block::</span>

<span class="sd">            self.cycle_couple[k] = (charge Clean_MIT_Cycle,</span>
<span class="sd">                                    discharge Clean_SEV_Cycle)</span>

<span class="sd">    C_rate : float</span>
<span class="sd">        The C rate associated to the battery for nondimensionning the</span>
<span class="sd">        current [A].</span>
<span class="sd">    Q_nominal : float</span>
<span class="sd">        The battery&#39;s nominal capacity (for nondimensionning the SOH) [A.h].</span>
<span class="sd">    V_nominal : float</span>
<span class="sd">        The battery&#39;s nominal voltage (for nondimensionning the voltage) [V].</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Battery</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="o">=</span><span class="mf">1.1</span><span class="o">/</span><span class="mi">50</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                 <span class="n">zlim</span><span class="o">=</span><span class="mi">6</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">C_rate</span> <span class="o">=</span> <span class="mf">1.1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">V_nominal</span> <span class="o">=</span> <span class="mf">3.6</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Q_nominal</span> <span class="o">=</span> <span class="mf">1.1</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">Name</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_life</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle_life</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">policy</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">policy</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="k">if</span> <span class="n">print_bool</span><span class="p">:</span>
            <span class="nb">print</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">))</span>

        <span class="c1"># capacity_test = []</span>
        <span class="c1"># for cycle in Battery.cycle:</span>
        <span class="c1">#     capacity_test.append(cycle.data.capacity)</span>

        <span class="k">for</span> <span class="n">cycle</span> <span class="ow">in</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">:</span> <span class="c1"># For each charge/discharge couple:</span>
            <span class="c1"># Here, a cycle corresponds to a cycle couple in the NASA Dataset.</span>
            <span class="c1"># For the discharge cycle first:</span>
            <span class="k">if</span> <span class="n">math</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">):</span> <span class="c1"># if the capacity is nan:</span>
                <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Cycle number &#39;</span><span class="p">,</span> <span class="n">cycle</span><span class="o">.</span><span class="n">number</span><span class="p">,</span> <span class="s1">&#39; NaN&#39;</span><span class="p">)</span>
                <span class="k">continue</span>    <span class="c1"># skip this couple</span>
            <span class="k">elif</span> <span class="n">cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span> <span class="o">&lt;</span> <span class="n">threshold</span><span class="p">:</span>
                <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Cycle number &#39;</span><span class="p">,</span> <span class="n">cycle</span><span class="o">.</span><span class="n">number</span><span class="p">,</span> <span class="s1">&#39; has capacity = &#39;</span><span class="p">,</span>
                      <span class="n">cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">,</span> <span class="s1">&#39; &lt; threshold = &#39;</span><span class="p">,</span> <span class="n">threshold</span><span class="p">)</span>
                <span class="k">continue</span>

            <span class="n">chr_data</span><span class="p">,</span> <span class="n">dis_data</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">clean_MIT_cycle_method</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span>
                                                             <span class="n">i_cutoff</span><span class="o">=</span><span class="n">i_cutoff</span><span class="p">,</span>
                                                             <span class="n">min_len</span><span class="o">=</span><span class="n">min_len</span><span class="p">)</span>

            <span class="k">if</span> <span class="n">chr_data</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="c1"># Cycle is too short.</span>
                <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Cycle number &#39;</span><span class="p">,</span> <span class="n">cycle</span><span class="o">.</span><span class="n">number</span><span class="p">,</span> <span class="s1">&#39; too short&#39;</span><span class="p">)</span>
                <span class="k">continue</span>

            <span class="n">chr_clean</span> <span class="o">=</span> <span class="n">Clean_MIT_Cycle</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span> <span class="n">chr_data</span><span class="p">,</span> <span class="s1">&#39;charge&#39;</span><span class="p">)</span>
            <span class="n">dis_clean</span> <span class="o">=</span> <span class="n">Clean_MIT_Cycle</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span> <span class="n">dis_data</span><span class="p">,</span> <span class="s1">&#39;discharge&#39;</span><span class="p">)</span>

            <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">old_dis_clean</span> <span class="o">=</span> <span class="n">dis_clean</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s1">&#39;Hi&#39;</span><span class="p">)</span> <span class="c1"># ????? todo</span>
                <span class="k">continue</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># Saving the cycle couple</span>
                <span class="c1"># print(chr_clean.number, old_dis_clean.number)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_clean</span><span class="p">,</span> <span class="n">old_dis_clean</span><span class="p">))</span>
                <span class="n">old_dis_clean</span> <span class="o">=</span> <span class="n">dis_clean</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span> <span class="c1"># 0 ou -1?? todo</span>

        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">)):</span>
            <span class="n">capacity_point</span> <span class="o">=</span> <span class="p">(</span><span class="n">i</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">)</span>     <span class="c1"># Defining the capacity point</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">capacity_point</span><span class="p">)</span>                      <span class="c1"># Saving the capacity point</span>

        <span class="c1"># Searching for outliers in the capacity data</span>
        <span class="n">cycle_couple</span><span class="p">,</span> <span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">Outliers</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">,</span>
                                                <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="p">,</span> <span class="n">z_lim</span><span class="o">=</span><span class="n">zlim</span><span class="p">)</span>

        <span class="c1"># plt.plot(capacity_test)</span>
        <span class="c1"># plt.show(block=True)</span>
        <span class="c1"># plt.plot(capacity_curve[:, 1])</span>
        <span class="c1"># plt.show(block=True)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="n">cycle_couple</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">capacity_curve</span>

<div class="viewcode-block" id="Clean_MIT_Battery.clean_MIT_cycle_method"><a class="viewcode-back" href="../sphinx/MIT.html#MIT_Classes.Clean_MIT_Battery.clean_MIT_cycle_method">[docs]</a>    <span class="k">def</span> <span class="nf">clean_MIT_cycle_method</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="o">=</span><span class="mf">1.1</span><span class="o">/</span><span class="mi">50</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Function for cleaning current, voltage and temperature data for a given</span>
<span class="sd">        cycle from the Severson et al. Dataset (full reference in note).</span>

<span class="sd">        The cleaning is done by removing outliers and then the last points of the</span>
<span class="sd">        cycle, when the current is being adjusted. The function will also separate</span>
<span class="sd">        the charge cycle from the discharge cycle, which come together in the</span>
<span class="sd">        dataset.</span>

<span class="sd">        This function is called upon initialization of a Clean_MIT_Battery class</span>
<span class="sd">        (see MIT_Classes.py for more information).</span>

<span class="sd">        .. note::</span>
<span class="sd">            This function uses the convention where the discharge current is</span>
<span class="sd">            negative and the charge current positive.</span>
<span class="sd">            If the cycle is deemed as too short or abnormal, then all of the arrays</span>
<span class="sd">            are returned as None.</span>

<span class="sd">        .. note::</span>
<span class="sd">            Full reference: Severson, K.A., Attia, P.M., Jin, N. et al.</span>
<span class="sd">            Data-driven prediction of battery cycle life before capacity</span>
<span class="sd">            degradation. Nat Energy 4, 383–391 (2019).</span>
<span class="sd">            &lt;https://doi.org/10.1038/s41560-019-0356-8&gt;</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        Cycle : MIT_Cycle</span>
<span class="sd">            The Cycle we want to clean.</span>
<span class="sd">        i_cutoff : float, default = 1.1/50</span>
<span class="sd">            The current cut-off value to be used to determine the end of the</span>
<span class="sd">            discharge cycles [A].</span>
<span class="sd">        min_len : int, default = 1</span>
<span class="sd">            The minimum amount of points a charge cycle must have to be considered</span>
<span class="sd">            as relevant. Equal to one by default. Something similar is done during</span>
<span class="sd">            the resampling stages in the dataset creation.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        Two tuples (ch_data, ds_data), each one containing the cleaned data for</span>
<span class="sd">        the charge and discharge cycle, respectively.</span>

<span class="sd">        ch_data = (time, current, voltage, temperature, capacity) (analogous for the</span>
<span class="sd">        discharge). Each entry is an np.ndarray.</span>

<span class="sd">        When one of the two cycles is too short (len(current) &lt; min_len), the cycle</span>
<span class="sd">        is scraped and the according tuple is returned as `None`.</span>

<span class="sd">        Raises</span>
<span class="sd">        ------</span>
<span class="sd">        AssertionError</span>
<span class="sd">            If `min_len` &lt; 1.</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">assert</span> <span class="n">min_len</span> <span class="o">&gt;=</span> <span class="mi">1</span><span class="p">,</span> <span class="s1">&#39;min_len must be greater or equal to 1&#39;</span>

        <span class="c1"># Numpy arrays</span>
        <span class="n">Cycle_t</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">time</span>  <span class="c1"># Time data</span>
        <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_i</span>  <span class="c1"># Current data</span>
        <span class="n">Cycle_v</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_v</span>  <span class="c1"># Voltage data</span>
        <span class="n">Cycle_T</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">meas_t</span>  <span class="c1"># Temperature data</span>
        <span class="n">Qd</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">dis_capacity</span>
        <span class="n">Qc</span> <span class="o">=</span> <span class="n">Cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">chr_capacity</span>

        <span class="c1"># Outliers</span>
        <span class="n">Data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_t</span><span class="p">,</span> <span class="n">Cycle_i</span><span class="p">,</span> <span class="n">Cycle_v</span><span class="p">,</span> <span class="n">Cycle_T</span><span class="p">,</span> <span class="n">Qd</span><span class="p">,</span> <span class="n">Qc</span><span class="p">],</span>
                              <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

        <span class="n">Data</span><span class="p">,</span> <span class="n">outlier_array</span> <span class="o">=</span> <span class="n">Input_outliers_v3</span><span class="p">(</span><span class="n">Data</span><span class="p">,</span> <span class="n">feature_index</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
        <span class="n">Cycle_t</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">:</span><span class="mi">1</span><span class="p">]</span>
        <span class="n">Cycle_i</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
        <span class="n">Data</span> <span class="o">=</span> <span class="n">Data</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">:]</span>

        <span class="c1"># Rest period:</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">idx_chr_time</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_t</span> <span class="o">&gt;</span> <span class="mi">10</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>

            <span class="k">if</span> <span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_chr_time</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="n">idx_chr_time</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_chr_time</span><span class="p">:,:]</span> <span class="o">==</span> <span class="mi">0</span>
                                        <span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span><span class="o">+</span><span class="n">idx_chr_time</span>
            <span class="c1"># 1C charge time:</span>
            <span class="n">idx_1c_time</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_chr_time</span><span class="p">:,</span> <span class="p">:]</span> <span class="o">&gt;</span> <span class="mi">0</span>
                                   <span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span><span class="o">+</span><span class="n">idx_chr_time</span>

            <span class="k">if</span> <span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">&lt;</span> <span class="mf">0.9</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:,</span> <span class="mi">0</span><span class="p">]):</span>
                <span class="n">idx_1c_time</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:,</span> <span class="p">:]</span> <span class="o">&gt;</span> <span class="mf">0.9</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span>
                    <span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:,</span> <span class="mi">0</span><span class="p">]</span>
                <span class="p">)</span>
                                       <span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">idx_1c_time</span>
        <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

        <span class="c1"># Taking away the first few charge curves:</span>
        <span class="c1"># Data = Data[idx_1c_time:, :]</span>
        <span class="c1"># Cycle_i = Cycle_i[idx_1c_time:, :]</span>
        <span class="c1"># Cycle_t = Cycle_t[idx_1c_time:, :]</span>

        <span class="c1"># Finding the index where the discharge starts:</span>
        <span class="n">idx</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:,</span> <span class="p">:]</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span><span class="o">+</span> <span class="n">idx_1c_time</span>

        <span class="c1"># Here we cut off the last bit of the curve where the current is yet again</span>
        <span class="c1"># lifted</span>

        <span class="k">if</span> <span class="n">Cycle_i</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">&gt;=</span> <span class="o">-</span><span class="n">i_cutoff</span><span class="p">:</span>  <span class="c1"># Analogous to the charge cycle.</span>
            <span class="c1"># Notice that we take awway the first 5 points in the analysis just to</span>
            <span class="c1"># make sure that an initial transient point won&#39;t cause any trouble</span>
            <span class="n">idx_ds</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx</span> <span class="o">+</span> <span class="mi">5</span><span class="p">:,</span> <span class="p">:]</span> <span class="o">&gt;=</span> <span class="o">-</span><span class="n">i_cutoff</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">idx</span> <span class="o">+</span> <span class="mi">5</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">idx_ds</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">)</span>

        <span class="c1"># Taking only the relevant data</span>
        <span class="c1"># Separating the vectors:</span>

        <span class="n">ch_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_t</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:</span><span class="n">idx</span><span class="p">,</span> <span class="p">:],</span>
                                  <span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:</span><span class="n">idx</span><span class="p">,</span> <span class="p">:],</span>
                                  <span class="n">Data</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:</span><span class="n">idx</span><span class="p">,</span> <span class="p">:</span><span class="mi">2</span><span class="p">],</span>
                                  <span class="n">Data</span><span class="p">[</span><span class="n">idx_1c_time</span><span class="p">:</span><span class="n">idx</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">:]],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

        <span class="n">ds_data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Cycle_t</span><span class="p">[</span><span class="n">idx</span><span class="p">:</span><span class="n">idx_ds</span><span class="p">,</span> <span class="p">:],</span> <span class="n">Cycle_i</span><span class="p">[</span><span class="n">idx</span><span class="p">:</span><span class="n">idx_ds</span><span class="p">,</span> <span class="p">:],</span>
                                  <span class="n">Data</span><span class="p">[</span><span class="n">idx</span><span class="p">:</span><span class="n">idx_ds</span><span class="p">,</span> <span class="p">:</span><span class="mi">2</span><span class="p">],</span> <span class="n">Data</span><span class="p">[</span><span class="n">idx</span><span class="p">:</span><span class="n">idx_ds</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">:]],</span>
                                 <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

        <span class="c1"># Checking if there are any NaNs:</span>
        <span class="k">if</span> <span class="n">np</span><span class="o">.</span><span class="n">any</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">Cycle_i</span><span class="p">,</span> <span class="o">-</span><span class="mi">1</span><span class="p">)))</span><span class="o">.</span><span class="n">item</span><span class="p">():</span>
            <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;NaNs in Cycle_i&quot;</span><span class="p">)</span>
            <span class="c1">#   TODO make this better: Input_outliers_v2 style</span>

        <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">ch_data</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">min_len</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">ds_data</span><span class="p">)</span> <span class="o">&lt;</span> <span class="n">min_len</span><span class="p">):</span>
            <span class="c1"># If the Cycle is too short, than we&#39;ll return None.</span>
            <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">ch_data</span><span class="p">,</span> <span class="n">ds_data</span></div></div>

<div class="viewcode-block" id="Clean_MIT_Cycle"><a class="viewcode-back" href="../sphinx/MIT.html#MIT_Classes.Clean_MIT_Cycle">[docs]</a><span class="k">class</span> <span class="nc">Clean_MIT_Cycle</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Class structured similarly to a Severson_Cycle, but only containing the</span>
<span class="sd">    cleaned data that is relevant for analysis.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    cycle : MIT_Cycle</span>
<span class="sd">        The Severson_Cycle object corresponding to this cycle.</span>
<span class="sd">    data : ndarray[floats]</span>
<span class="sd">        The array containing all of the data.</span>
<span class="sd">        Each column corresponds to a different variable, in the following</span>
<span class="sd">        order: [time, current, voltage, temperature, capacity].</span>
<span class="sd">        Units: [s], [A], [V], [ºC] and [A.h] respectively.</span>
<span class="sd">    type : {&#39;charge&#39;, &#39;discharge&#39;}</span>
<span class="sd">        A string expressing which kind of cycle it corresponds to. Can either</span>
<span class="sd">        be &#39;charge&#39; or &#39;discharge&#39;.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    type : {&#39;charge&#39;, &#39;discharge&#39;}</span>
<span class="sd">        The type of cycle.</span>
<span class="sd">    amb_T : int</span>
<span class="sd">        The ambient temperature during measurements [ºC].</span>
<span class="sd">        It&#39;s always 30ºC in this case.</span>
<span class="sd">    summary_keys : list(str)</span>
<span class="sd">        A list containing the name of the following attributes:</span>

<span class="sd">        IR : float</span>
<span class="sd">            Measured internal resistance.</span>
<span class="sd">        QCharge : float</span>
<span class="sd">            The charge cycle&#39;s capacity.</span>
<span class="sd">        QDischarge : float</span>
<span class="sd">            The discharge cycle&#39;s capacity.</span>
<span class="sd">        Tavg : float</span>
<span class="sd">            The cycle&#39;s average temperature.</span>
<span class="sd">        Tmax : float</span>
<span class="sd">            The cycle&#39;s maximum temperature.</span>
<span class="sd">        Tmin : float</span>
<span class="sd">            The cycle&#39;s minimum temperature.</span>
<span class="sd">        chargetime : float</span>
<span class="sd">            The charge cycle&#39;s duration.</span>
<span class="sd">        cycle : float</span>
<span class="sd">            The cycle number + 1.</span>

<span class="sd">    battery_keys : list</span>
<span class="sd">        A list containing the name of the variables stored in the battery group.</span>
<span class="sd">    data : Clean_MIT_Data</span>
<span class="sd">        Clean_Sev_Data class containing all of the actual data.</span>
<span class="sd">        See Clean_Sev_Data for more information.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cycle</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="nb">type</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">type</span> <span class="o">=</span> <span class="nb">type</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">number</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">amb_T</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">summary_keys</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">summary_keys</span>

        <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">summary_keys</span><span class="p">:</span>
            <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="nb">getattr</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span> <span class="n">key</span><span class="p">))</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">battery_keys</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">battery_keys</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="n">Clean_MIT_Data</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="nb">type</span><span class="p">)</span></div>

<div class="viewcode-block" id="Clean_MIT_Data"><a class="viewcode-back" href="../sphinx/MIT.html#MIT_Classes.Clean_MIT_Data">[docs]</a><span class="k">class</span> <span class="nc">Clean_MIT_Data</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Data class for the cleaned Severson data.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    cycle : MIT_Cycle</span>
<span class="sd">        The Severson_Cycle object corresponding to this cycle.</span>
<span class="sd">    data : ndarray[floats]</span>
<span class="sd">        The array containing all of the data.</span>
<span class="sd">        Each column corresponds to a different variable, in the following</span>
<span class="sd">        order: [time, current, voltage, temperature, capacity].</span>
<span class="sd">        Units: [s], [A], [V], [ºC] and [A.h] respectively.</span>
<span class="sd">    type : {&#39;charge&#39;, &#39;discharge&#39;}</span>
<span class="sd">        A string expressing which kind of cycle it corresponds to. Can either</span>
<span class="sd">        be &#39;charge&#39; or &#39;discharge&#39;.</span>

<span class="sd">    Attributes</span>
<span class="sd">    ----------</span>
<span class="sd">    time : ndarray[floats]</span>
<span class="sd">        Time vector for the cycle [min].</span>
<span class="sd">    meas_v : ndarray[floats]</span>
<span class="sd">        Battery terminal voltage [V].</span>
<span class="sd">    meas_i : ndarray[floats]</span>
<span class="sd">        Battery output current [A].</span>
<span class="sd">    meas_t : ndarray[floats]</span>
<span class="sd">        Battery temperature [ºC].</span>

<span class="sd">    if type == &#39;charge&#39;:</span>
<span class="sd">        chr_capacity : ndarray[floats]</span>
<span class="sd">            The battery charge capacity during cycling [A.h].</span>
<span class="sd">    elif type == &#39;discharge&#39;:</span>
<span class="sd">        dis_capacity : ndarray[floats]</span>
<span class="sd">            The battery discharge capacity evolution during cycling [A.h].</span>
<span class="sd">        dis_dQdV : ndarray[floats]</span>
<span class="sd">            The differential capacity curve calculated from the discharge data.</span>
<span class="sd">        capacity : float</span>
<span class="sd">            The battery&#39;s calculated discharge capacity at the end of the cycle</span>
<span class="sd">            [A.h].</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    Exception</span>
<span class="sd">        If the type isn&#39;t &#39;charge&#39; nor &#39;discharge&#39;.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cycle</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="nb">type</span><span class="p">):</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">0</span><span class="p">:</span><span class="mi">1</span><span class="p">]</span><span class="o">*</span><span class="mi">60</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">2</span><span class="p">:</span><span class="mi">3</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">meas_t</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">3</span><span class="p">:</span><span class="mi">4</span><span class="p">]</span>
        <span class="k">if</span> <span class="nb">type</span> <span class="o">==</span> <span class="s1">&#39;charge&#39;</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">chr_capacity</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">4</span><span class="p">:</span><span class="mi">5</span><span class="p">]</span>
        <span class="k">elif</span> <span class="nb">type</span> <span class="o">==</span> <span class="s1">&#39;discharge&#39;</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">dis_capacity</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">4</span><span class="p">:</span><span class="mi">5</span><span class="p">]</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">dis_dQdV</span> <span class="o">=</span> <span class="n">data</span><span class="p">[:,</span> <span class="mi">5</span><span class="p">:</span><span class="mi">6</span><span class="p">]</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;Unknown type: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="nb">type</span><span class="p">))</span></div>

<span class="c1">########################################################################################</span>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="kn">import</span> <span class="nn">os</span>
    <span class="kn">import</span> <span class="nn">pickle</span>
    <span class="kn">import</span> <span class="nn">re</span>

    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Datasets/Severson et al./Raw Dataset&#39;</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//2. 2017-06-30&#39;</span><span class="p">)</span>

    <span class="c1"># Creating the raw batteries</span>
    <span class="n">f</span> <span class="o">=</span> <span class="n">h5py</span><span class="o">.</span><span class="n">File</span><span class="p">(</span><span class="s1">&#39;2017-06-30_batchdata_updated_struct_errorcorrect.mat&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">battery_number</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">f</span><span class="p">[</span><span class="s1">&#39;batch&#39;</span><span class="p">][</span><span class="s1">&#39;cycle_life&#39;</span><span class="p">])):</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">battery_number</span><span class="p">)</span>
        <span class="n">f</span> <span class="o">=</span> <span class="n">h5py</span><span class="o">.</span><span class="n">File</span><span class="p">(</span><span class="s1">&#39;2017-06-30_batchdata_updated_struct_errorcorrect.mat&#39;</span><span class="p">)</span>
        <span class="n">B</span> <span class="o">=</span> <span class="n">Dataset_MIT</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">battery_number</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">battery_number</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;_Dataset_Severson.txt&#39;</span><span class="p">,</span>
                  <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f_2</span><span class="p">:</span>
            <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">B</span><span class="p">,</span> <span class="n">f_2</span><span class="p">)</span>

    <span class="c1"># Creating the cleaned datasets:</span>
    <span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>  <span class="c1"># All files in the folder</span>
    <span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>  <span class="c1"># List with the valid files</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
        <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{1}</span><span class="s1">&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>  <span class="c1"># Only take into acount</span>
        <span class="c1"># the battery files</span>
        <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">B</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="nb">print</span><span class="p">(</span><span class="n">B</span><span class="o">.</span><span class="n">Name</span><span class="p">)</span>
        <span class="n">Battery</span> <span class="o">=</span> <span class="n">Clean_MIT_Battery</span><span class="p">(</span><span class="n">B</span><span class="p">)</span>

        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Cleaned_v2/2. 2017-06-30&#39;</span><span class="p">)</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">Battery</span><span class="o">.</span><span class="n">Name</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">Battery</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>
        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Raw Dataset/2. 2017-06-30&#39;</span><span class="p">)</span>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>